#!/usr/bin/env python
from tools import file_writer, parser, cleaner
import paths as pt

def main():
    parser20 = parser.Parser2020()
    ats = parser20.parse_assistive_aids(pt.PATHS_2020[0], pt.RAW_DATA_DIR_2020)
    td = parser20.parse_training_done(pt.PATHS_2020[1], pt.RAW_DATA_DIR_2020)
    sc = parser20.parse_screening_content(pt.PATHS_2020[1], pt.RAW_DATA_DIR_2020)
    tc = parser20.parse_training_cancelled(pt.PATHS_2020[1], pt.RAW_DATA_DIR_2020)
    ss = parser20.parse_status_set(pt.PATHS_2020[1], pt.RAW_DATA_DIR_2020)
    ic = parser20.parse_iso_classes('isoall.txt', pt.REFERENCES_DIR)
    fd = parser20.parse_fall_data(pt.PATHS_2020[2], pt.RAW_DATA_DIR_2020)

    cleaner2020 = cleaner.Cleaner2020()
    patient_data = td[['CitizenId', 'Gender', 'BirthYear']].drop_duplicates(keep='first')
    patient_data = cleaner2020.clean_patient_data(patient_data)
    screening_content = cleaner2020.clean_screening_content(sc, patient_data)
    status_set = cleaner2020.clean_status_set(ss, patient_data)
    training_done = cleaner2020.clean_training_done(td, patient_data)
    training_cancelled = cleaner2020.clean_training_cancelled(tc, patient_data)
    assistive_aids = cleaner2020.clean_assistive_aids(ats, ic)
    fall_data = cleaner2020.clean_fall_data(fd)
    
    file_writer.write_pickle(patient_data, pt.INTERIM_DATA_DIR, 'pd.pkl')
    file_writer.write_pickle(screening_content, pt.INTERIM_DATA_DIR, 'sc.pkl')
    file_writer.write_pickle(status_set, pt.INTERIM_DATA_DIR, 'ss.pkl')
    file_writer.write_pickle(training_done, pt.INTERIM_DATA_DIR, 'td.pkl')
    file_writer.write_pickle(training_cancelled, pt.INTERIM_DATA_DIR, 'tc.pkl')
    file_writer.write_pickle(assistive_aids, pt.INTERIM_DATA_DIR, 'ats.pkl')
    file_writer.write_pickle(ic, pt.INTERIM_DATA_DIR, 'ic.pkl')
    file_writer.write_pickle(fall_data, pt.INTERIM_DATA_DIR, 'fd.pkl')
    
if __name__ == "__main__":
    main()
    